/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.community.vo.ResidentialVO;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.constant.BladeConstant;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.entity.AccessRecord;
import org.springblade.estate.entity.Car;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.entity.CarEnterRecord;
import org.springblade.estate.vo.CarEnterRecordVO;
import org.springblade.estate.wrapper.CarEnterRecordWrapper;
import org.springblade.estate.service.ICarEnterRecordService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/carenterrecord")
@Api(value = "", tags = "接口")
public class CarEnterRecordController extends BladeController {

	private final ICarEnterRecordService carEnterRecordService;
	private final IOrgPositionClient orgPositionClient;
	private final IResidentialClient residentialClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入carEnterRecord")
	public R<CarEnterRecordVO> detail(CarEnterRecord carEnterRecord) {
		CarEnterRecord detail = carEnterRecordService.getOne(Condition.getQueryWrapper(carEnterRecord));
		return R.data(CarEnterRecordWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入carEnterRecord")
	public R<IPage<CarEnterRecordVO>> list(@RequestParam Map<String, Object> carEnterRecord, Query query, BladeUser bladeUser) {
		QueryWrapper<CarEnterRecord> queryWrapper = Condition.getQueryWrapper(carEnterRecord, CarEnterRecord.class);
		queryWrapper.lambda().orderByDesc(CarEnterRecord::getCreateTime);
		IPage<CarEnterRecord> pages = carEnterRecordService.page(Condition.getPage(query), (!bladeUser.getTenantId().equals(BladeConstant.ADMIN_TENANT_ID)) ? queryWrapper.lambda().eq(CarEnterRecord::getTenantId, bladeUser.getTenantId()) : queryWrapper);
		return R.data(CarEnterRecordWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入carEnterRecord")
	public R<IPage<CarEnterRecordVO>> page(CarEnterRecordVO carEnterRecord, Query query) {
		IPage<CarEnterRecordVO> pages = carEnterRecordService.selectCarEnterRecordPage(Condition.getPage(query), carEnterRecord);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入carEnterRecord")
	public R save(@Valid @RequestBody CarEnterRecord carEnterRecord) {
		return R.status(carEnterRecordService.save(carEnterRecord));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入carEnterRecord")
	public R update(@Valid @RequestBody CarEnterRecord carEnterRecord) {
		return R.status(carEnterRecordService.updateById(carEnterRecord));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入carEnterRecord")
	public R submit(@Valid @RequestBody CarEnterRecord carEnterRecord) {
		Residential residential = new Residential();
		residential.setId(carEnterRecord.getResidentialId());
		ResidentialVO residentialVO = residentialClient.detail(residential);
		carEnterRecord.setOrgPosition(residentialVO.getOrgPosition());
		return R.status(carEnterRecordService.saveOrUpdate(carEnterRecord));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(carEnterRecordService.deleteLogic(Func.toLongList(ids)));
	}
	/**
	 * 入场记录初始化，关联新的小区和图片去除前缀
	 */
	@PostMapping("/initData")

	public R initData() {
		long beginTime = System.currentTimeMillis();
		List<CarEnterRecord> carEnterRecordList = this.carEnterRecordService.getBaseMapper().selectList(new QueryWrapper<>(new CarEnterRecord()));
		carEnterRecordList.forEach(carEnterRecord -> {
			if (carEnterRecord.getEnterImgPath() != null)
				carEnterRecord.setEnterImgPath(carEnterRecord.getEnterImgPath().replace("http://139.9.103.171:1888/miniofile/", ""));

			if(carEnterRecord.getResidentialId() != null){
				Residential searchResidential = new Residential();
				searchResidential.setGridId(carEnterRecord.getResidentialId());

				ResidentialVO detail = residentialClient.detail(searchResidential);
				if (detail != null) {
					carEnterRecord.setResidentialId(detail.getId());
					carEnterRecord.setOrgPosition(detail.getOrgPosition());
					carEnterRecord.setAgencyId(detail.getAgencyId());

				}
			}

			carEnterRecordService.updateById(carEnterRecord);

		});
		long endTime = System.currentTimeMillis();
		return R.data("耗时：" + (endTime - beginTime) / 1000 + "秒");
	}

}
